%global _python_bytecompile_errors_terminate_build 0

Epoch: 1

%global install_loc %{_datadir}/eclipse/dropins

Summary: Eclipse Python development plug-in
Name:    eclipse-pydev
Version:          3.5.0
Release:          1%{?dist}
License:          EPL
URL:              http://pydev.org
Group:            Development/Tools
#Fetched from https://github.com/fabioz/Pydev/archive/pydev_3_5_0.tar.gz
Source0:          Pydev-pydev_3_5_0.tar.gz

Patch0:           remove-winregistry.patch
Patch1:           pydev-remove-jython.patch
Patch2:           remove-iInfo-error.patch

BuildRequires:    java-devel >= 1.7.0
BuildArch:        noarch

Requires: eclipse-platform
Requires: python
Requires: apache-commons-codec >= 1.3
Requires: apache-commons-logging
Requires: xmlrpc-common
Requires: xmlrpc-client
Requires: xmlrpc-server
Requires: junit >= 3.8.1
Requires: jython >= 2.2
Requires: pylint
Requires: jpathwatch
Requires: python-django 
Requires: ws-commons-util
Requires: python-ipython-console
Requires: python-libs
BuildRequires:    eclipse-pde
BuildRequires:    eclipse-mylyn
BuildRequires:    eclipse-mylyn-context-team >= 3.5.0
BuildRequires:    eclipse-mylyn-ide >= 3.5.0
BuildRequires:    javapackages-tools >= 0:1.5
BuildRequires:    junit >= 3.8.1
BuildRequires:    apache-commons-codec >= 1.3
BuildRequires:    apache-commons-logging
BuildRequires:    ws-commons-util
BuildRequires:    xmlrpc-common
BuildRequires:    xmlrpc-client
BuildRequires:    xmlrpc-server
BuildRequires:    jython >= 2.2
BuildRequires:    jpathwatch
BuildRequires:    tycho-extras
BuildRequires:    feclipse-maven-plugin
BuildRequires:    eclipse-p2-discovery

%description
The eclipse-pydev package contains Eclipse plugins for
Python development.

%package  mylyn
Summary:  Pydev Mylyn Focused UI
Requires: eclipse-mylyn
Requires: %{name} = %{epoch}:%{version}-%{release}
Group: Development/Tools

%description mylyn
Mylyn Task-Focused UI extensions for Pydev.

%prep
%setup -q -n Pydev-pydev_3_5_0
%patch0 
%patch1
%patch2 -p1

#fix mylyn plugin version
sed --in-place 's:libs/,\\:libs/:' plugins/org.python.pydev/build.properties 
sed --in-place 's:libs/WinRegistry-4.5.jar::' plugins/org.python.pydev/build.properties

# remove pre-generated build files
find . -name build.xml | xargs rm

# remove pre-built jars
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;

# Remove inlined jython sources.
rm -rf plugins/org.python.pydev.jython/src_jython

# link to system jars
ln -sf %{_javadir}/commons-codec.jar \
       plugins/org.python.pydev.core/commons-codec.jar

ln -sf %{_javadir}/junit.jar \
       plugins/org.python.pydev.core/lib/junit.jar

ln -sf %{_jnidir}/jpathwatch.jar \
       plugins/org.python.pydev.core/lib/jpathwatch-0-95.jar

mkdir plugins/org.python.pydev.jython/lib/
ln -sf %{_javadir}/jython.jar \
       plugins/org.python.pydev.jython/lib/jython.jar

ln -sf %{_datadir}/jython/Lib \
       plugins/org.python.pydev.jython/Lib

ln -sf %{_javadir}/commons-logging.jar \
       plugins/org.python.pydev.shared_interactive_console/commons-logging-1.1.1.jar

ln -sf %{_javadir}/ws-commons-util.jar \
       plugins/org.python.pydev.shared_interactive_console/ws-commons-util-1.0.2.jar

ln -sf %{_javadir}/xmlrpc-client.jar \
       plugins/org.python.pydev.shared_interactive_console/xmlrpc-client-3.1.3.jar

ln -sf %{_javadir}/xmlrpc-common.jar \
       plugins/org.python.pydev.shared_interactive_console/xmlrpc-common-3.1.3.jar

ln -sf %{_javadir}/xmlrpc-server.jar \
       plugins/org.python.pydev.shared_interactive_console/xmlrpc-server-3.1.3.jar

%build
xmvn -o clean verify

%install
installDir=${RPM_BUILD_ROOT}/%{install_loc}/pydev
install -d -m755 $installDir
install -d -m755 ${installDir}-mylyn

xmvn -o org.fedoraproject:feclipse-maven-plugin:install -DsourceRepo=features/org.python.pydev.p2-repo/target/org.python.pydev.p2-repo-%{version}-SNAPSHOT.zip -DtargetLocation=$installDir

mv $installDir/plugins/*mylyn* ${installDir}-mylyn/plugins/
mv $installDir/features/*mylyn* ${installDir}-mylyn/features/
qualifier=`ls $installDir/features/|grep pydev.feature|cut -d _ -f 2|cut -d . -f 4`
# deal with linked deps
pushd $installDir/plugins
rm -rf org.python.pydev.core_%{version}.$qualifier/commons-codec.jar
ln -sf %{_javadir}/commons-codec.jar \
       org.python.pydev.core_%{version}.$qualifier/commons-codec.jar

file=`find . -name commons-logging-1.1.1.jar`
rm -f $file
ln -sf %{_javadir}/commons-logging.jar $file

file=`find . -name ws-commons-util-1.0.2.jar`
rm -f $file
ln -sf %{_javadir}/ws-commons-util.jar $file

file=`find . -name xmlrpc-client-3.1.3.jar`
rm -f $file
ln -sf %{_javadir}/xmlrpc-client.jar $file

file=`find . -name xmlrpc-common-3.1.3.jar`
rm -f $file
ln -sf %{_javadir}/xmlrpc-common.jar $file

file=`find . -name xmlrpc-server-3.1.3.jar`
rm -f $file
ln -sf %{_javadir}/xmlrpc-server.jar $file

# Symlink and copy required python libs before deleting Lib dir.
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/jython/Lib
cp org.python.pydev.jython_%{version}.$qualifier/Lib/textwrap.py ${RPM_BUILD_ROOT}%{_datadir}/jython/Lib

rm -rf org.python.pydev.jython_%{version}.$qualifier/Lib
ln -sf %{_datadir}/jython/Lib \
       org.python.pydev.jython_%{version}.$qualifier/Lib

ln -sf %{_javadir}/jython.jar \
       org.python.pydev.jython_%{version}.$qualifier/lib
popd

# convert .py$ files from mode 0644 to mode 0755
sixFourFourfiles=$(find ${RPM_BUILD_ROOT} -name '*\.py' -perm 0644 | xargs)
if [ ${sixFourFourfiles:-0} -ne 0 ]; then
  chmod 0755 ${sixFourFourfiles}
fi

%post
ln -sf /usr/lib`arch | sed 's/x86_//;s/i686//'`/python2.7/optparse.py %{_datadir}/jython/Lib/optparse.py

%postun
rm -f  %{_datadir}/jython/Lib/optparse.py

%files
%{install_loc}/pydev
%{_datadir}/jython/Lib/*

%files mylyn
%{install_loc}/pydev-mylyn

%changelog
* Thu May 29 2014 Alexander Kurtakov <akurtako@redhat.com> 1:3.5.0-1
- Update to 3.5.0.

* Thu Mar 20 2014 Alexander Kurtakov <akurtako@redhat.com> 1:3.4.1-1
- Update to 3.4.1.

* Wed Feb 12 2014 Alexander Kurtakov <akurtako@redhat.com> 1:3.3.3-1
- Update to 3.3.3.

* Mon Dec 30 2013 Alexander Kurtakov <akurtako@redhat.com> 1:3.2.0-1
- Update to 3.2.0.

* Fri Dec 13 2013 Alexander Kurtakov <akurtako@redhat.com> 1:3.1.0-1
- Update to 3.1.0.

* Mon Nov 11 2013 Alexander Kurtakov <akurtako@redhat.com> 1:3.0-1
- Update to 3.0.
- Drop old changelog now that we move to tycho builds.
